/*
 * Domain.java
 *
 * Created on February 18, 2002, 5:10 PM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 * Domain assertion (for roles).
 * @author  Michael Sintek
 * @version 
 */
public class Domain extends Assertion {

  Expression _expr1, _expr2;
  
  /** Creates new Domain */
  public Domain(Expression expr1, Expression expr2) {
    _expr1 = expr1;
    _expr2 = expr2;
  }
  
  public void print (Syntax syntax, PrintWriter out) {
    if (syntax.XML ()) {
      out.print ("<DOMAIN>");
      out.print("<ROLE>");
      _expr1.print (syntax, out);
      out.print("</ROLE>");
      out.print("<CONCEPT>");
      _expr2.print (syntax, out);
      out.print("</CONCEPT>");
      out.println ("</DOMAIN>");
    } else {
      out.print ("(domain ");
      _expr1.print (syntax, out);
      out.print (" ");
      _expr2.print (syntax, out);
      out.println (")");
    }
  }
  
  public void toSHIQ(KB kb) {
    // (domain r c) -> (implies (some r TOP) c)
    kb.add(new Implies(
      new Some(_expr1.toSHIQ(kb, ROLE), Symbol.TOP), _expr2.toSHIQ(kb, CONCEPT)));
  }
  
}
