/*
 * Syntax.java
 *
 * Created on February 18, 2002, 10:53 AM
 */

package org.semanticweb.dl;

/**
 * Default Syntax for DL (close to FaCT LISP syntax).
 * @author  Michael Sintek
 * @version 
 */
public class Syntax {

  KB _kb;

  public Syntax(KB kb) {
    _kb = kb;
  }
  
  public boolean isConcept(Symbol symbol) {
    return _kb.isConcept(symbol);
  }
  
  public boolean LISP() { return true; }
  public boolean XML() { return false; }
  public boolean TRIPLE() { return false; }
  public boolean DOT() { return false; }
  public boolean DAML() { return false; }
  
  public String EQUAL() { return "equal"; }
  public String IMPLIES() { return "implies"; }

  public boolean showDefconcept() { return true; }
  public boolean showDefrole() { return true; }

  // splitter between abbreviation and local name
  public String abbrevSplitter() { return "+"; } // not : to make it LISP-friendly!
  
}
