package org.semanticweb.glp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

/**
 *  Title: Triple Description: RDF Query and Inference Language Copyright:
 *  Copyright (c) 2001 Company: Stanford University
 *
 *@author     Stefan Decker
 *@created    January 17, 2002
 *@version    1.0
 */

public class GLPImpliedBy extends GLPBinaryOperator {
    /**
     *  Constructor for the GLPImpliedBy object
     *
     *@param  l  Description of the Parameter
     *@param  r  Description of the Parameter
     */
    public GLPImpliedBy(GLogicFormula l, GLogicFormula r) {
        super(l,r);
    }

    public final GLogicFormula copyFormula(HashMap h) {
        return new GLPImpliedBy(l.copyFormula(h), r.copyFormula(h));
    }

    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        return toString(l, " <- ", r);
    }
}
