package org.semanticweb.glp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import org.semanticweb.lp.Literal;

/**
 *  Title: Triple Description: RDF Query and Inference Language Copyright:
 *  Copyright (c) 2001 Company: Stanford University
 *
 *@author     Stefan Decker
 *@created    January 17, 2002
 *@version    1.0
 */

public class GLPNot extends GLPUnaryOperator {

    /**
     *  Constructor for the GLPNot object
     *
     *@param  f  Description of the Parameter
     */
    public GLPNot(GLogicFormula f) {
        super(f);
    }


    /**
     *  Gets the literal attribute of the GLPNot object
     *
     *@return    The literal value
     */
    public boolean isLiteral() {
        return (f instanceof GLPAtom);
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public Literal toLPLiteral() {
        return ((GLPAtom) f).toLPLiteral(false);
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        return toString("not", f);
    }


    /**
     *  Description of the Method
     *
     *@param  h  Description of the Parameter
     *@return    Description of the Return Value
     */
    public final GLogicFormula copyFormula(HashMap h) {
        return new GLPNot(f.copyFormula(h));
    }

}
