package org.semanticweb.triple.inference;

/*
 *  Name: DB.java
 *  Version: 1.0
 *  Purpose: stores all facts
 *  History:
 */
import java.io.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class DB implements DBInterface {
    Atoms facts[] = null;
    // Feld von Faktenmengen der Regelmenge
    int increment = 200;
    // dynamische Erweiterung der Felder facts um incr
    int maxpreds = 0;


    // grsstes bisher aufgetretenes Prdikatsymbol

    /**
     *  Constructor for the DB object
     */
    public DB() {
        // Konstruktor
        maxpreds = increment - 1;
        facts = new Atoms[increment];
    }


    /**
     *  Description of the Method
     *
     *@param  sym   Description of the Parameter
     *@param  fact  Description of the Parameter
     */
    public void AddFact(int sym, GroundAtom fact) {
        // Fgt ein einzelnes Faktum  hinzu

        // boolean inserted;
        // int i;
        // if (sym == 6) {fact.print(System.out); System.out.println();}
        // falls noetig RuleSet erweitern
        checksym(sym);
        if (facts[sym] == null) {
            // noch kein Faktum dieses Prdikatsymbols vorhanden
            // Erzeugen einer neuen Faktenmenge dieses Symbols
            facts[sym] = new Atoms(fact.terms.length);
            //System.out.print(sym); System.out.print(":"); System.out.println(fact.terms.length);
        }
        // Einfgen des Faktums in die Faktenmenge
        fact = facts[sym].Insert(fact);
    }


    /**
     *  Description of the Method
     *
     *@param  sym  Description of the Parameter
     */
    private void checksym(int sym) {
        // neues Prdikatsymbol
        // falls noetig RuleSet erweitern
        if (sym > maxpreds) {
            extend(sym);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  sym   Description of the Parameter
     *@param  fact  Description of the Parameter
     */
    public void DeleteFact(int sym, GroundAtom fact) {
        // Lscht ein  Faktum
        GroundAtom a;
        if (facts[sym] != null) {
            a = facts[sym].Search(fact);
            if (a != null) {
                //System.out.println("found");
                facts[sym].Delete(a);
            }
        }
    }


    /**
     *  Description of the Method
     *
     *@param  r  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int EvalRule(Rule r) {
        return 0;
    }


    /**
     *  Description of the Method
     *
     *@param  index  Description of the Parameter
     */
    private void extend(int index) {
        // erweitert das Feld facts so dass sie auch den Index 'index' enthalten
        int len;
        // erweitert das Feld facts so dass sie auch den Index 'index' enthalten
        int i;
        Atoms newfacts[];
        len = maxpreds + 1;
        if (maxpreds < index) {
            while (len < index + 1) {
                len += increment;
            }
            newfacts = new Atoms[len];
            for (i = 0; i <= maxpreds; i++) {
                newfacts[i] = facts[i];
            }
            facts = newfacts;
        }
        maxpreds = len - 1;
    }


    /**
     *  Description of the Method
     *
     *@param  praedikatsymbol  Description of the Parameter
     *@param  filterterme      Description of the Parameter
     *@return                  Description of the Return Value
     */
    public Atoms GetFacts(int praedikatsymbol, Atoms filterterme) {
        /*
         *  Das ist die wesentliche Funktion zum Zugriff auf Fakten. Es werden auf Fakten mit dem Prdikatsymbol praedikatsymbol zugegriffen. Der Zugriff wird mit Hilfe einer Menge von Filtertermen filterterme eingeschrnkt. Ein Filterterm ist ein Tupel von Termen, die Variablen enthalten knnen. Z.B. ist f(X,a),"hallo",X
         *  ein solcher Filterterm. Das Ergebnis des Aufrufs ist eine Menge von Fakten, die zu diesen Filtertermen "passen" (die mit einem der Filterterme matchen).
         *  Z.B. enthalte die entsprechende Tabelle der DB die Zeilen:
         *  5, "hallo",8
         *  f(7,a), "hallo",7
         *  f(ab,a), "hallo",ab
         *  f(7,a), "hallo",h
         *  f(ab,a), "huhu",ab
         *  Die filterterme bestehen nur aus dem einen Filterterm: f(X,a),"hallo",X. Dann ist das Ergebnis des Aufrufs die folgende Menge von Fakten:
         *  f(7,a), "hallo",7
         *  f(ab,a), "hallo",ab
         */
        /*
         *  System.out.println("Filterterme:");
         *  filterterme.print(System.out);
         *  System.out.println("-------------------------------------");
         */
        Atoms res = null;
        if (filterterme == null) {
            res = facts[praedikatsymbol];
            System.out.println("DB: 1");
        }
        else if (facts[praedikatsymbol] != null) {
            /*
             *  System.out.println("verfgbar:");
             *  facts[praedikatsymbol].print(System.out);
             *  System.out.println("-------------------------------------");
             */
            res = new Atoms(facts[praedikatsymbol].arity);
            res.Filtering1(filterterme, facts[praedikatsymbol]);
        }
        /*
         *  System.out.print("Prdikatsymbol: "); System.out.println(praedikatsymbol);
         *  System.out.println("Ergebnis:");
         *  if (res != null) res.print(System.out);
         *  System.out.println("===============================================");
         */
        return res;
    }


    /**
     *  Description of the Method
     *
     *@param  praedikatsymbol  Description of the Parameter
     *@return                  Description of the Return Value
     */
    public long GetNumber(int praedikatsymbol) {
        // liefert die Anzahl der Fakten
        if (facts[praedikatsymbol] != null) {
            return facts[praedikatsymbol].anztuples;
        }
        else {
            return 0;
        }
    }


    /**
     *  Description of the Method
     *
     *@param  praedikatsymbol  Description of the Parameter
     *@param  i                Description of the Parameter
     *@return                  Description of the Return Value
     */
    public TermSet GetTerms(int praedikatsymbol, int i) {
        /*
         *  Dies wird fr Optimierungszwecke gebraucht. Liefert die Menge von Termen,
         *  die am i-ten Argument aller Fakten des Prdikatsymbols praedikatsymbol auftreten.
         */
        TermSet terms;

        if (facts[praedikatsymbol] != null) {
            terms = new TermSet();
            facts[praedikatsymbol].Terms(terms, i);
            //terms.print(System.out);
            return terms;
        }
        else {
            return new TermSet();
        }
    }


    /**
     *  Gets the evaluable attribute of the DB object
     *
     *@param  r  Description of the Parameter
     *@return    The evaluable value
     */
    public boolean isEvaluable(Rule r) {
        return false;
    }


    /**
     *  Description of the Method
     *
     *@param  file             Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void read(RandomAccessFile file) throws IOException {
        String s = "";
        SParser spars;

        spars = new SParser(null);
        while ((s = file.readLine()) != null) {
            try {
                spars.decode(null, this, s + "\n");
            } catch (SParseError p) {
                System.out.println(p.getMessage());
            }

        }
    }


    /**
     *  Description of the Method
     *
     *@param  p                Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void write(PrintStream p) throws IOException {
        /*
         *  Schreibt die Faktenmenge im internen Format auf p heraus
         */
        int i;
        for (i = 0; i < facts.length; i++) {
            if (facts[i] != null) {
                facts[i].internalize(p, i);
            }
        }
    }
}
