package org.semanticweb.triple.inference;

/*
 *  Name: NumTerm.java
 *  Version: 1.2
 *  Purpose: Represents Number Constants
 *  History: function internalize1 returning Strings added (jan)
 *  interface simplified (jan)
 */
import java.io.*;
import java.util.*;
import java.net.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class NumTerm extends Term {
    // type = 2
    /**
     *  Description of the Field
     */
    public double zahl;


    // NumTerm wird durch zahl reprsentiert

    /**
     *  Constructor for the NumTerm object
     *
     *@param  z  Description of the Parameter
     */
    public NumTerm(double z) {
        // Zahlkonstante
        super(new Term[0]);
        zahl = z;
    }


    /**
     *  Constructor for the NumTerm object
     *
     *@param  z      Description of the Parameter
     *@param  terms  Description of the Parameter
     */
    public NumTerm(double z, Term terms[]) {
        // Funktion mit Zahl z als Funktionssymbol
        // terms enthaelt die Parameter
        super(terms);
        zahl = z;
    }


    /**
     *  Constructor for the NumTerm object
     *
     *@param  z            Description of the Parameter
     *@param  stelligkeit  Description of the Parameter
     *@param  grnd         Description of the Parameter
     */
    public NumTerm(double z, int stelligkeit, boolean grnd) {
        // Funktion mit Zahl als Funktionssymbol, Stelligkeit stelligkeit
        // grnd gibt an, ob die Parameter Variablen enthalten oder nicht
        super(stelligkeit, grnd);
        zahl = z;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public Term CloneFlat() {
        return new NumTerm(zahl, pars.length, ground);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int CompareFlat(Term t) {
        // Vergleich eines NumTerms mit einem anderen NumTerm
        return zahl <= ((NumTerm) t).zahl ? (zahl < ((NumTerm) t).zahl ? -1 : 0) : 1;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String InternalizeFlat() {
        return "n" + String.valueOf(zahl);
    }


    /**
     *  Gets the numTerm attribute of the NumTerm object
     *
     *@return    The numTerm value
     */
    public boolean isNumTerm() {
        return true;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toStringFlat() {
        return String.valueOf(zahl);
    }


    /**
     *  Description of the Method
     *
     *@param  p  Description of the Parameter
     *@param  f  Description of the Parameter
     *@param  s  Description of the Parameter
     *@return    Description of the Return Value
     */
    public String toStringFlat(String p[], String f[], String s[]) {
        // Ausgabe als String, ids ist die Symboltabelle fr Konstanten und Funktionssymbole
        Double d = new Double(zahl);
        return d.toString();
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int Type() {
        return 2;
    }
}
