package org.semanticweb.triple.inference;
import java.applet.*;
import java.awt.*;
import java.util.*;
import java.util.Date;
import java.net.*;
import java.io.*;
import org.semanticweb.triple.inference.builtins.BuiltinConfig;
import org.semanticweb.lp.Term;
import org.semanticweb.lp.VariableTerm;
import org.semanticweb.lp.DoubleTerm;
import org.semanticweb.lp.FunctorTerm;
import org.semanticweb.lp.LPParser;
import org.semanticweb.lp.LPParseException;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class SimpleEvaluator extends Object {

    /**
     *  Description of the Field
     */
    public RuleSet RS;
    /**
     *  Description of the Field
     */
    public boolean stratified = false;
    // is set of rules stratified?
    /**
     *  Description of the Field
     */
    public boolean compiled = false;
    // is set of rules compiled?
    /**
     *  Description of the Field
     */
    public boolean evaluated = false;
    // has set of rules been evaluated already?
    /**
     *  Description of the Field
     */
    public boolean optimized = false;
    // is set of rules optimized?
    /**
     *  Description of the Field
     */
    public boolean strat = false;
    // has stratification been performed?
    /**
     *  Description of the Field
     */
    public boolean strong = false;
    // has detection of strong components in rule graph been performed
    /**
     *  Description of the Field
     */
    public Hashtable Names;
    /**
     *  Description of the Field
     */
    public Hashtable Numbers;
    /**
     *  Description of the Field
     */
    public PrintStream out = null;
    /**
     *  Description of the Field
     */
    public BuiltinConfig builtins;
    /**
     *  Description of the Field
     */
    public Symbolhandler symbols = null;
    /**
     *  Description of the Field
     */
    public SimpleEvaluatorConfig config;
    /**
     *  Description of the Field
     */
    public DBInterface db;
    LPParser sparser = null;


//SParser spars = null;

    /**
     *  Constructor for the SimpleEvaluator object
     */
    public SimpleEvaluator() { }


    /**
     *  Description of the Method
     */
    public void Clear() {
        RS.ClearRuleSet();
    }


    /**
     *  Description of the Method
     *
     *@param  filename       Description of the Parameter
     *@exception  Exception  Description of the Exception
     */
    public void compileSimpleFile(String filename) throws Exception {
        compileSimpleStream(new FileInputStream(filename));
    }


    /**
     *  Description of the Method
     *
     *@param  Rules                     Description of the Parameter
     *@exception  LPParseException      Description of the Exception
     */
    public void compileSimpleStream(InputStream Rules) throws LPParseException {
        if (sparser == null) {
            //sparser = new LPParser(this, Rules);
        }
        else {
            sparser.reInit(Rules);
        }
        //sparser.compile();
        compiled = true;
    }


    /**
     *  Description of the Method
     *
     *@param  rules                     Description of the Parameter
     *@exception  LPParseException      Description of the Exception
     */
    public void compileSimpleString(String rules) throws LPParseException {
        compileSimpleStream(new StringBufferInputStream(rules));
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public Vector computeSimpleSubstitutions() {
        Vector QSubst = new Vector();
        for (Rule q = RS.NextQuery(null); q != null; q = RS.NextQuery(q)) {
            QSubst.addElement(computeSingleSubstitution(q));
        }
        return QSubst;
    }


    /**
     *  Description of the Method
     *
     *@param  q  Description of the Parameter
     *@return    Description of the Return Value
     */
    public Vector computeSingleSubstitution(Rule q) {
        int i;
        int k;
        int m;
        int j;
        Vector Vars = (Vector) Names.get(q);
        Vector Nums = (Vector) Numbers.get(q);
        Vector SetSubst = new Vector();
        Substitution S = RS.LastSubstitution(q);
        k = S.index.length;
        if (Nums == null) {
            j = 0;
        }
        else {
            j = Nums.size();
        }
        Atom A = (Atom) S.First();
        while (A != null) {
//A.print(System.out);
            Vector SingleSubst = new Vector();
            for (i = 0; i < j; i++) {
                if (Nums.elementAt(i) != null && S.index[((Integer) (Nums.elementAt(i))).intValue()] >= 0) {
                    SingleSubst.addElement(new SimpleSubst((String) Vars.elementAt(i),
                            toSimpleTerm(A.terms[S.index[((Integer) Nums.elementAt(i)).intValue()]], symbols)));
                }
            }
            SetSubst.addElement(SingleSubst);
            A = (Atom) S.Next();
        }
        return SetSubst;
    }


    /*
     *  public void write(RandomAccessFile f) throws IOException {
     *  f.writeBytes(String.valueOf(symbols.getSizeFunctionSymbols())+"\n");
     *  f.writeBytes(String.valueOf(symbols.getSizeStrings())+"\n");
     *  f.writeBytes(String.valueOf(symbols.getSizePredicateSymbols())+"\n");
     *  symbols.writeFunctionSymbols(f);
     *  symbols.writeStrings(f);
     *  symbols.writePredicateSymbols(f);
     *  }
     *  public void read(RandomAccessFile f) throws IOException {
     *  int fsyms, strings, psyms;
     *  String s;
     *  int i;
     *  int index, index1;
     *  int symbol;
     *  String str;
     *  int arity;
     *  int len;
     *  s = f.readLine(); fsyms = wandle(s);
     *  s = f.readLine(); strings = wandle(s);
     *  s = f.readLine(); psyms = wandle(s);
     *  for(i = 0; i < fsyms; i++) {
     *  s = f.readLine();
     *  index = s.indexOf(' ');
     *  symbol = wandle(s.substring(0,index));
     *  index1 = s.indexOf(' ',index+1);
     *  /System.out.print(s); System.out.print("   ");
     *  / System.out.print(index); System.out.print(" "); System.out.println(index1);
     *  arity = wandle(s.substring(index+1,index1));
     *  str = s.substring(index1+1);
     *  symbols.searchAndInsertFunctionSymbols(str,arity);
     *  }
     *  for(i = 0; i < strings; i++) {
     *  s = f.readLine();
     *  index = s.indexOf(' ');
     *  symbol = wandle(s.substring(0,index));
     *  index1 = s.indexOf(' ',index+1);
     *  /System.out.print(s); System.out.print("   ");
     *  / System.out.print(index); System.out.print(" "); System.out.println(index1);
     *  len = wandle(s.substring(index+1,index1));
     *  str = s.substring(index1+1);
     *  while (str.length()<len-1) {
     *  str = str + "\n" + f.readLine();
     *  }
     *  symbols.searchAndInsertStrings(str);
     *  / System.out.println(str);
     *  }
     *  for(i = 0; i < psyms; i++) {
     *  s = f.readLine();
     *  index = s.indexOf(' ');
     *  symbol = wandle(s.substring(0,index));
     *  index1 = s.indexOf(' ',index+1);
     *  /System.out.print(s); System.out.print("   ");
     *  / System.out.print(index); System.out.print(" "); System.out.println(index1);
     *  arity = wandle(s.substring(index+1,index1));
     *  str = s.substring(index1+1);
     *  symbols.searchAndInsertPredicateSymbols(str,arity);
     *  }
     *  }
     */
    /**
     *  Description of the Method
     */
    public void deleteQueries() {
        Rule q;
        for (q = RS.NextQuery(null); q != null; q = RS.NextQuery(q)) {
            RS.DeleteRule(q);
        }
        Names = new Hashtable();
        Numbers = new Hashtable();
    }


    /**
     *  Description of the Method
     *
     *@param  q  Description of the Parameter
     */
    public void deleteQuery(Rule q) {
        Names.remove(q);
        Numbers.remove(q);
        RS.DeleteRule(q);
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public boolean dynamic() {
        int i;
        Rule q;
        boolean retvalue = false;
        if (!compiled) {
            System.out.println("Please compile first\n");
        }
        else if (!stratified) {
            System.out.println("Cannot evaluate because rules are not stratified\n");
        }
        else {
            RS.EvaluationMethod(1);
            evaluated = true;
            retvalue = RS.EvalQueries();
        }
        return retvalue;
    }


    /**
     *  Description of the Method
     */
    public void evaluate() {
        int i = config.getEvaluationmethod();
        if (i == config.WELLFOUNDED) {
            strongcomponents();
            while (wellfounded()) {
                ;
            }
        }
        else if (i == config.ALTERNATINGFIXPOINT) {
            wellfoundedAF();
        }
        else if (i == config.DYNAMIC) {
            stratify();
            while (dynamic()) {
                ;
            }
        }
        else if (i == config.NAIVE) {
            stratify();
            naive();
        }
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public boolean evaluatenext() {
        int i = config.getEvaluationmethod();
        if (i == config.WELLFOUNDED) {
            strongcomponents();
            return wellfounded();
        }
        else if (i == config.ALTERNATINGFIXPOINT) {
            return wellfoundedAF();
        }
        else if (i == config.DYNAMIC) {
            stratify();
            return dynamic();
        }
        else if (i == config.NAIVE) {
            stratify();
            return naive();
        }
        return false;
    }


    /**
     *  Gets the builtins attribute of the SimpleEvaluator object
     *
     *@return    The builtins value
     */
    public BuiltinConfig getBuiltins() {
        return builtins;
    }


    /**
     *  Gets the ruleset attribute of the SimpleEvaluator object
     *
     *@return    The ruleset value
     */
    public RuleSet getRuleset() {
        return RS;
    }


    /**
     *  Gets the simpleEvaluatorConfig attribute of the SimpleEvaluator object
     *
     *@return    The simpleEvaluatorConfig value
     */
    public SimpleEvaluatorConfig getSimpleEvaluatorConfig() {
        return config;
    }


    /**
     *  Gets the string attribute of the SimpleEvaluator object
     *
     *@param  symbol  Description of the Parameter
     *@return         The string value
     */
    public String getString(int symbol) {
        return symbols.getContentStrings(symbol - config.STRINGSTART);
    }


    /*
     *  public SParser getSParser() {
     *  return spars;
     *  }
     */
    /**
     *  Gets the symbolhandler attribute of the SimpleEvaluator object
     *
     *@return    The symbolhandler value
     */
    public Symbolhandler getSymbolhandler() {
        return symbols;
    }


    /**
     *  Description of the Method
     */
    public void InferOff() {
        RS.InferOff();
    }


    /**
     *  Description of the Method
     */
    public void InferOn() {
        RS.InferOn();
    }


    /**
     *  Description of the Method
     */
    public void init() {
        init(new SimpleEvaluatorConfig());
    }


    /**
     *  Description of the Method
     *
     *@param  conf  Description of the Parameter
     */
    public void init(SimpleEvaluatorConfig conf) {
        config = conf;
        builtins = new BuiltinConfig(this);
        // spars = new SParser(builtins);
        db = config.getDatabase();

        RS = new RuleSet(builtins, db);

        /*
         *  if (config.getRuleoutput() != null)
         *  RS.writeonly(config.getRuleoutput());
         */
        symbols = config.getSymbolhandler();
        compiled = false;
        stratified = true;
        Names = new Hashtable();
        Numbers = new Hashtable();

        symbols.searchAndInsertFunctionSymbols("+", 2);
        // 0
        symbols.searchAndInsertFunctionSymbols("-", 2);
        // 1
        symbols.searchAndInsertFunctionSymbols("*", 2);
        //  2
        symbols.searchAndInsertFunctionSymbols("/", 2);
        // 3
        symbols.searchAndInsertFunctionSymbols("%", 2);
        // 4
        symbols.searchAndInsertFunctionSymbols("E", 0);
        // 5
        symbols.searchAndInsertFunctionSymbols("PI", 0);
        // 6
        symbols.searchAndInsertFunctionSymbols("RANDOM", 0);
        // 7

        symbols.searchAndInsertFunctionSymbols("abs", 1);
        // 8
        symbols.searchAndInsertFunctionSymbols("sin", 1);
        // 9
        symbols.searchAndInsertFunctionSymbols("cos", 1);
        // 10
        symbols.searchAndInsertFunctionSymbols("tan", 1);
        // 11
        symbols.searchAndInsertFunctionSymbols("asin", 1);
        // 12
        symbols.searchAndInsertFunctionSymbols("acos", 1);
        // 13
        symbols.searchAndInsertFunctionSymbols("ceil", 1);
        // 14
        symbols.searchAndInsertFunctionSymbols("floor", 1);
        // 15
        symbols.searchAndInsertFunctionSymbols("exp", 1);
        // 16
        symbols.searchAndInsertFunctionSymbols("log", 1);
        // 17
        symbols.searchAndInsertFunctionSymbols("rint", 1);
        // 18
        symbols.searchAndInsertFunctionSymbols("sqrt", 1);
        // 19
        symbols.searchAndInsertFunctionSymbols("round", 1);
        // 20

        symbols.searchAndInsertFunctionSymbols("max", 2);
        // 21
        symbols.searchAndInsertFunctionSymbols("min", 2);
        // 22
        symbols.searchAndInsertFunctionSymbols("pow", 2);
        // 23


        builtins.init(symbols);

    }


    /**
     *  Description of the Method
     *
     *@param  args           Description of the Parameter
     *@exception  Exception  Description of the Exception
     */
    public static void main(String args[]) throws Exception {
        SimpleEvaluator eval = new SimpleEvaluator();
        eval.init();
        int i = 0;
        while (i < args.length) {
            eval.compileSimpleFile(args[i]);
            i++;
        }
        eval.stratify();
        eval.evaluate();
        eval.printSubs(eval.computeSimpleSubstitutions());

    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public boolean naive() {
//System.out.println("Naive");
        boolean retvalue = false;
        if (!compiled) {
            System.out.println("Please compile first\n");
        }
        else if (!stratified) {
            System.out.println("Cannot evaluate because rules are not stratified\n");
        }
        else {
            RS.EvaluationMethod(0);
            evaluated = true;
            retvalue = RS.EvalQueries();
        }
        return retvalue;
    }


    /**
     *  Description of the Method
     */
    public void optimize() {
        boolean optimization[];
        if (!optimized) {
            optimization = config.getOptimization();
            if (optimization[0]) {
                RS.Optimize1();
            }
            else if (optimization[1]) {
                RS.Optimize2();
            }
            if (optimization[2]) {
                stratify();
                RS.Optimize3();
            }
            optimized = true;
        }
    }


    /**
     *  Description of the Method
     *
     *@param  QSubst  Description of the Parameter
     */
    public void printSubs(Vector QSubst) {
        java.util.Enumeration e;
        java.util.Enumeration f;
        java.util.Enumeration g;
        boolean nextline = false;
        for (e = QSubst.elements(); e.hasMoreElements(); ) {
            for (f = ((Vector) (e.nextElement())).elements(); f.hasMoreElements(); ) {
                for (g = ((Vector) (f.nextElement())).elements(); g.hasMoreElements(); ) {
                    System.out.println(g.nextElement().toString());
                    nextline = true;
                }
                if (nextline) {
                    System.out.println();
                }
                nextline = false;
            }
        }
    }


    /**
     *  Description of the Method
     */
    public void Rollback() {
        getSymbolhandler().rollback();
        RS.Rollback();
    }


    /**
     *  Sets the builtins attribute of the SimpleEvaluator object
     *
     *@param  builtins  The new builtins value
     */
    public void setBuiltins(BuiltinConfig builtins) {
        this.builtins = builtins;
    }


    /**
     *  Description of the Method
     */
    public void SetRollbackPoint() {
        getSymbolhandler().setRollbackPoint();
        RS.SetRollbackPoint();
    }


    /**
     *  Sets the ruleset attribute of the SimpleEvaluator object
     *
     *@param  RS  The new ruleset value
     */
    public void setRuleset(RuleSet RS) {
        this.RS = RS;
    }


    /**
     *  Sets the simpleEvaluatorConfig attribute of the SimpleEvaluator object
     *
     *@param  config  The new simpleEvaluatorConfig value
     */
    public void setSimpleEvaluatorConfig(SimpleEvaluatorConfig config) {
        this.config = config;
    }


    /**
     *  Sets the string attribute of the SimpleEvaluator object
     *
     *@param  s  The new string value
     *@return    Description of the Return Value
     */
    public int setString(String s) {
        return symbols.searchAndInsertStrings(s) + config.STRINGSTART;
    }


    /**
     *  Sets the symbolhandler attribute of the SimpleEvaluator object
     *
     *@param  symbols  The new symbolhandler value
     */
    public void setSymbolhandler(Symbolhandler symbols) {
        this.symbols = symbols;
    }


    /**
     *  Description of the Method
     */
    public void stratify() {
        if (!strat) {
            stratified = RS.Stratify();
            strat = true;
        }
    }


    /**
     *  Description of the Method
     */
    private void strongcomponents() {
        if (!strong) {
            RS.StrongComponents();
            strong = true;
        }
    }


    /**
     *  A unit test for JUnit
     *
     *@param  q  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean testSubstitutions(Rule q) {
        Substitution S = RS.Substitution(q);
        Atom A = (Atom) S.First();
        return A != null;
    }


    /**
     *  Description of the Method
     *
     *@param  A        Description of the Parameter
     *@param  symbols  Description of the Parameter
     *@return          Description of the Return Value
     */
    public org.semanticweb.lp.Term toSimpleTerm(org.semanticweb.triple.inference.Term A, Symbolhandler symbols) {
        if (A instanceof Variable) {
            return new VariableTerm("X" + Integer.toString(((Variable) A).symbol));
        }
        else if (A instanceof NumTerm) {
            return new DoubleTerm(((NumTerm) A).zahl);
        }
        else if (A instanceof StringTerm) {
            return new org.semanticweb.lp.StringTerm(((org.semanticweb.triple.inference.StringTerm) A).s);
        }
        else if (A instanceof org.semanticweb.triple.inference.ConstTerm) {
            org.semanticweb.triple.inference.ConstTerm C = (org.semanticweb.triple.inference.ConstTerm) A;
            if (C.symbol >= config.STRINGSTART) {
                return new org.semanticweb.lp.ConstTerm(symbols.getContentStrings(C.symbol - config.STRINGSTART));
            }
            String s1 = (String) symbols.getContentFunctionSymbols(C.symbol);
            org.semanticweb.lp.Term[] t = new org.semanticweb.lp.Term[C.anzpars()];
            if (C.anzpars() > 0) {
                for (int i = 0; i < C.anzpars(); i++) {
                    t[i] = toSimpleTerm(C.pars[i], symbols);
                }
            }
            return new FunctorTerm(s1, t);
        }
        return null;
    }


    /**
     *  Description of the Method
     *
     *@param  s  Description of the Parameter
     *@return    Description of the Return Value
     */
    int wandle(String s) {
        Integer zahl = new Integer(0);
        try {
            zahl = new Integer(s);
        } catch (NumberFormatException p) {
            System.out.println("number expected");
        }
        return zahl.intValue();
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public boolean wellfounded() {
        int i;
        Rule q;
        long sec1;
        long sec2;
        boolean retvalue = false;
        if (!compiled) {
            System.out.println("Please compile first\n");
        }
        else {
            RS.EvaluationMethod(3);
            sec1 = (new Date()).getTime();
            retvalue = RS.EvalQueries();
            sec2 = (new Date()).getTime();
            //System.out.print("milliseconds used: "); System.out.println(sec2-sec1);
            evaluated = true;
        }
        return retvalue;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public boolean wellfoundedAF() {
        int i;
        Rule q;
        boolean retvalue = false;
        if (!compiled) {
            System.out.println("Please compile first\n");
        }
        else {
            RS.EvaluationMethod(2);
            evaluated = true;
            retvalue = RS.EvalQueries();
        }
        return retvalue;
    }
}
