package org.semanticweb.triple.inference;

/*
 *  Name: Atoms.java
 *  Version: 2.0
 *  Purpose: a container for atoms with appropriate access data structures
 *  (AVL trees)
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class Subsumption extends Operation {
    /**
     *  Constructor for the Subsumption object
     *
     *@param  R1   Description of the Parameter
     *@param  ix1  Description of the Parameter
     *@param  R2   Description of the Parameter
     *@param  ix2  Description of the Parameter
     *@param  T    Description of the Parameter
     */
    public Subsumption(Atoms R1, int ix1[], Atoms R2, int ix2[], long T) {
        super(R1, ix1, R2, ix2, T);
        comp1 = new CompareAtoms(ix1, ix2);
        comp2 = new CompareAtoms(ix2, ix1);
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     *@param  t2  Description of the Parameter
     */
    public void op(GroundAtom t1, GroundAtom t2) {
        boolean res = true;
        Atom t1n = (Atom) t1;
        Atom t2n = (Atom) t2;
        if (t1n != t2n) {
            if (t2n.lasttouched < timestamp) {
                res = (t2n).Match(t1n);
                if (res) {
                    if (t1n.lasttouched < timestamp) {
                        t1n.next2 = R1.tuples2;
                        R1.tuples2 = t1n;
                        t1n.lasttouched = timestamp;
                    }
                }
                (t2n).ClearVariables();
            }
        }
    }
}
