package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


public class Resource extends Term {

  // String uri; <- version for TRIPLE0/RDF; now it breaks :-(
  Term namespace;
  Term localName;

  public Resource() {}
  // public Resource(String uri) { this.uri = uri; }

  /*
  public void putURI(String uri) { this.uri = uri; }
  public String getURI() { return uri; }
  */
  
  public void putNamespace(Term namespace) { this.namespace = namespace; }
  public void putLocalName(Term localName) { this.localName = localName; }
  
  public Term getNamespace() { return namespace; }
  public Term getLocalName() { return localName; }
  
  public String toString(Syntax syntax) {
    // return uri; // normalize, lookup namespace etc. ... !!!
    return namespace.toString(syntax) + ":" + localName.toString(syntax);
  }
  
  public GLPTerm toGLP(GLPTerm glpModel, ArrayList glpFormulae) {
    // -> resource(ns', ln') + add. formulae
    ArrayList glpArgs = new ArrayList();
    glpArgs.add(namespace.toGLP(glpModel, glpFormulae));
    glpArgs.add(localName.toGLP(glpModel, glpFormulae));
    GLPTermFunction glpResource = new GLPTermFunction("resource", glpArgs);
    return glpResource;
  }
  
}
