package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


public class Structure extends Term {

  String functor;
  ArrayList args = new ArrayList(); // of Term

  public void putFunctor(String functor) { this.functor = functor; }

  public void putArgs(Term term) { args.add(term); }
  public void putArgs(String name) { args.add(new Literal(name)); }

  public String getFunctor() { return functor; }
  public ArrayList getArgs() { return args; }

  public String toString(Syntax syntax) {
    StringBuffer buffer = new StringBuffer();
    buffer.append(syntax.getSymbol(functor));
    buffer.append("(");
    if (args != null && args.size() > 0) {
      for (Iterator termIterator = args.iterator();
	   termIterator.hasNext();) {
	Term term = (Term)termIterator.next();
	buffer.append(term.toString(syntax));
	if (termIterator.hasNext())
	  buffer.append(", ");
      }
    }
    buffer.append(")");
    return buffer.toString();
  }

  public GLPTerm toGLP(GLPTerm glpModel, ArrayList glpFormulae) {
    // s(a1, ...) -> s'(a1', ...) + additional glpFormulae
    ArrayList glpArgs = new ArrayList();
    for (Iterator argIterator = args.iterator();
	 argIterator.hasNext();) {
      Term arg = (Term)argIterator.next();
      GLPTerm glpArg = (GLPTerm)arg.toGLP(glpModel, glpFormulae);
      glpArgs.add(glpArg);
    }
    return new GLPTermFunction(functor, glpArgs);
  }
  
}
