package org.semanticweb.triple.language;

import java.util.*;


/** The root of all TRIPLE language expressions. */
abstract public class TripleExpression {

  abstract public String toString(Syntax syntax);

  public String toTripleString() {
    return toString(new TripleSyntax());
  }

  public String toPrologString() {
    return toString(new PrologSyntax());
  }

  public String toString() {
    return toTripleString();
  }


  // auxiliaries

  static void appendList(ArrayList list, StringBuffer buffer,
      Syntax syntax, String separator) {
    // append list of TripleExpressions to end of buffer
    if (list != null) {
      for (Iterator listIter = list.iterator(); listIter.hasNext();) {
        TripleExpression expr = (TripleExpression)listIter.next();
        buffer.append(expr.toString(syntax));
        if (listIter.hasNext())
          buffer.append(separator);
      }
    }
  }
  
}
