package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


public class Variable extends Term {

  // uri is not used at the moment;
  // we have to rethink it wrt. TRIPLE in RDF !!!
  
  String uri;
  String label;

  public Variable() {}
  public Variable(String label) { this.label = label; }

  public void putURI(String uri) { this.uri = uri; }
  public void putLabel(String label) { this.label = label; }

  public String getURI() { return uri; }
  public String getLabel() { return label; }

  public String toString(Syntax syntax) {
    return syntax.getVariable(label);
  }

  public boolean isAnonymous() {
    return label == null;
  }
  
  public GLPTerm toGLP (GLPTerm glpModel, ArrayList glpFormulae) {
    if (!isAnonymous())
      return new GLPTermVariable(label);
    else
      return new GLPTermVariable(); // anonymous variable
  }

  // auxiliaries
  
  static public ArrayList toGLPVariables(ArrayList variables) {
    ArrayList glpVariables = new ArrayList();
    for (Iterator varIter = variables.iterator(); varIter.hasNext();) {
      glpVariables.add(
        new GLPTermVariable(((Variable)varIter.next()).getLabel()));
    }
    return glpVariables;
  }
  
}
